package pl.edu.icm.synat.logic.services.process.node.common;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.springframework.batch.item.ItemProcessor;

public class CollectionFlattenProcessor<T, U> implements ItemProcessor<Collection<T>, Collection<U>> {

	protected ItemProcessor<T, U> baseWriter;

	public CollectionFlattenProcessor(ItemProcessor<T, U> baseWriter) {
		this.baseWriter = baseWriter;
	}


	@Override
	public Collection<U> process(Collection<T> items) throws Exception {
		List<U> result = new LinkedList<U>();
		for (T item : items) {
			result.add(baseWriter.process(item));
		}
		return result;
	}

}
