package pl.edu.icm.synat.logic.services.process.node.common;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.springframework.batch.item.ItemWriter;

public class CollectionFlattenWriter<T> implements ItemWriter<Collection<T>> {

	protected ItemWriter<T> baseWriter;

	public CollectionFlattenWriter(ItemWriter<T> baseWriter) {
		this.baseWriter = baseWriter;
	}

	@Override
	public void write(List<? extends Collection<T>> items) throws Exception {
		List<T> mergedItems = new LinkedList<T>();
		for (Collection<T> item : items) {
			mergedItems.addAll(item);
		}
		baseWriter.write(mergedItems);
	}

}
