package pl.edu.icm.synat.logic.services.process.node.common;

import java.util.List;

import org.springframework.batch.item.ItemProcessor;

import com.google.common.collect.Lists;

import pl.edu.icm.synat.application.exception.GeneralBusinessException;

public class ListWrapperProcessor<I, O> implements ItemProcessor<I, O>{

	private ItemProcessor<List<I>, List<O>> listProcessor;

	public void setListProcessor(ItemProcessor<List<I>, List<O>> listProcessor) {
		this.listProcessor = listProcessor;
	}
	
	@Override
	public O process(I item) throws Exception {
		if (item == null) {
			return null;
		}
		
		@SuppressWarnings("unchecked")
		List<I> itemList = Lists.newArrayList(item);
		List<O> listResults = listProcessor.process(itemList);
		
		if (listResults == null || listResults.size() == 0) {
			return null;
		}
		if (listResults.size() > 1) {
			throw new GeneralBusinessException("Processing of single element lists produced list with more then one element");
		}
		return listResults.get(0);
	}
	
}
