package pl.edu.icm.synat.process.common.enrich;

/*
 * #%L
 * Synat: Importer integration tests for various sources
 * %%
 * Copyright (C) 2010 - 2013 ICM, Warsaw University
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.List;

import pl.edu.icm.model.bwmeta.y.YElement;

/**
 * Enrich {@code YElement} meta data.
*
* @author Gra <Gołębiewski Radosław A.> google.com/+RadoslawGolebiewski
*
*/
public interface MetadataEnricher {
    /**
     * Enrich {@code Bwmeta} meta data in {@code String}.
     * 
     * @param bwmeta, {@code Bwmeta} for Enrich.
     * @return {@code Bwmeta} in {@code String} with enriched meta data.
     */
    String enrich(String bwmeta);
    /**
     * Enrich {@code YElement} meta data.
     * 
     * @param elements, {@code YElement} {@code List} for Enrich.
     * @return {@code YElement} with enriched meta data.
     */
    YElement enrich(List<YElement> elements);
}
