package pl.edu.icm.synat.process.common.enrich;

/*
 * #%L
 * Synat: Importer integration tests for various sources
 * %%
 * Copyright (C) 2010 - 2013 ICM, Warsaw University
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import pl.edu.icm.model.bwmeta.y.YElement;

/**
 * Write enrich informations in existing {@code YElement}.
*
* @author Gra <Gołębiewski Radosław A.> google.com/+RadoslawGolebiewski
*
*/
public interface MetadataTransformer {
    /**
     * Enrich existing {@code YElement} with informations.
     * As a principle of limited trust for out source information provided.
     * 
     * @param element, {@code YElement}on witch informations will be enriched.
     * @return true if {@code YElement} was modify
     */
    boolean modify(YElement element);
}
