package pl.edu.icm.synat.process.common.enrich.impl;

import org.springframework.beans.factory.annotation.Required;

import pl.edu.icm.model.bwmeta.y.YElement;
import pl.edu.icm.synat.application.exception.BwmetaValidationException;
import pl.edu.icm.synat.logic.repository.YElementEnricher;
import pl.edu.icm.synat.process.common.enrich.MetadataTransformer;

public class StructureBuilderEnricher implements MetadataTransformer {

    private YElementEnricher elementEnricher;

    @Override
    public boolean modify(YElement element) {
        try {
            return elementEnricher.enrich(element);
        } catch (BwmetaValidationException e) {
            return false;
        }
    }

    @Required
    public void setElementEnricher(YElementEnricher elementEnricher) {
        this.elementEnricher = elementEnricher;
    }

}
