package pl.edu.icm.synat.process.common.harvesting;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import pl.edu.icm.model.bwmeta.y.YCategoryRef;

/**
 * Results of harvesting journal data.
 *
 */
public class HarvestingResult implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * Journal or journal volume site URL
	 */
	private String siteUrl;
	
	/**
	 * Url to cover
	 */
	private String coverUrl;
	
	/**
	 * Journal description 
	 */
	private String desciption;

    /**
     * Journal impact factor 
     */
    private BigDecimal impactFactor;

    /**
     * Journal frequency TODO define what dose it mean
     */
    private String frequency;

    private List<YCategoryRef> categories = new ArrayList<YCategoryRef>();
    
    private TitleHistory otherTitles;

	public String getCoverUrl() {
		return coverUrl;
	}

	public void setCoverUrl(String coverUrl) {
		this.coverUrl = coverUrl;
	}

	public String getDesciption() {
		return desciption;
	}

	public void setDesciption(String desciption) {
		this.desciption = desciption;
	}

	public String getSiteUrl() {
		return siteUrl;
	}

	public void setSiteUrl(String siteUrl) {
		this.siteUrl = siteUrl;
	}

    public BigDecimal getImpactFactor() {
        return impactFactor;
    }

    public void setImpactFactor(String impactFactor) {
        this.impactFactor = new BigDecimal(impactFactor);
    }

    public void setImpactFactor(BigDecimal impactFactor) {
        this.impactFactor = impactFactor;
    }

    public String getFrequency() {
        return frequency;
    }

    public void setFrequency(String frequency) {
        this.frequency = frequency;
    }

    public List<YCategoryRef> getCategories() {
        return categories;
    }

    public void setCategories(List<YCategoryRef> categories) {
        this.categories.addAll(categories);
    }

    public TitleHistory getOtherTitles() {
        return otherTitles;
    }

    public void setOtherTitles(TitleHistory otherTitles) {
        this.otherTitles = otherTitles;
    }
    
}
