package pl.edu.icm.synat.process.common.harvesting;

import pl.edu.icm.synat.logic.document.model.api.Document;

public interface MetadataHarvester {
	
	/**
	 * Verify if given harvester can be used for given document 
	 */
	boolean isApplicable(Document document);
	
	/**
	 * Tries to finds cover without metadata.
	 * Document will not be changed.
	 * @return null if cover was not found or HarvestingResult with siteUrl and coverUrl
	 */
	HarvestingResult findCover(Document document);
	
	/**
	 * Tries to finds cover and metadata. 
	 * Document will not be changed.
	 * @return null if neither cover not metadata was not found. 
	 * Otherwise HarvestingResult with siteUrl and coverUrl or metadata (or both)  
	 */
	HarvestingResult findCoverAndMetadata(Document document);
}
