package pl.edu.icm.synat.process.common.harvesting;

/*
 * #%L
 * Synat: harvester License.
 * %%
 * Copyright (C) 2010 - 2013 ICM, Warsaw University
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.List;

import pl.edu.icm.model.bwmeta.y.YCategoryRef;

/**
 * Subject discipline mapper interface.
 * All subjects given in parameter should be mapped to list of disciplines.
*
* @author Gra <Gołębiewski Radosław A.> google.com/+RadoslawGolebiewski
*
*/
public interface SubjectDisciplineMapper {
    /**
     * Convert given subjects as a {@code String} {@code List} to
     * {@code List} of {@code YCategoryRef} with root categories too.
     * Not only basic categories that are one to one from subjects.
     * @param subjects
     * @return
     */
    List<YCategoryRef> convertSubjects(List<String> subjects);
}
