package pl.edu.icm.synat.process.common.node;

import org.apache.commons.lang.StringUtils;
import org.springframework.batch.item.ItemProcessor;

import pl.edu.icm.synat.logic.document.model.api.NativeDocument;
import pl.edu.icm.synat.logic.services.repository.constants.RepositoryStoreConstants;
import pl.edu.icm.synat.services.process.ProcessIdentifierHolder;

public class NativeDocumentTagProcessor implements ItemProcessor<NativeDocument, NativeDocument> {

	private String definitionId;
	private ProcessIdentifierHolder processIdHolder; 
	
	public void setDefinitionId(String definitionId) {
		this.definitionId = definitionId;
	}
	
	public void setProcessIdHolder(ProcessIdentifierHolder processIdHolder) {
		this.processIdHolder = processIdHolder;
	}

	@Override
	public NativeDocument process(NativeDocument nativeDocument) throws Exception {
		
		nativeDocument.addTagByKey(RepositoryStoreConstants.TAG_NAME_CREATION_TIMESTAMP, ""+System.currentTimeMillis());
		if (processIdHolder != null) {
			nativeDocument.addTagByKey(RepositoryStoreConstants.TAG_NAME_IMPORT, processIdHolder.getProcessId());
		}
		if (StringUtils.isNotBlank(definitionId)) {
			nativeDocument.addTagByKey(RepositoryStoreConstants.TAG_NAME_IMPORT_DATA_SOURCE_DEFINITIONS, definitionId);
		}
		
		return nativeDocument;
	}
}
