package pl.edu.icm.synat.process.common.node;

import org.springframework.batch.item.ItemProcessor;
import org.springframework.beans.factory.annotation.Required;

public abstract class SkippableNode<I> implements ItemProcessor<I, I> {

    protected boolean processingEnabled = true;

    @Override
    public final I process(final I input) {
        if (processingEnabled) {
            return innerProcess(input);
        }
        return input;
    }

    public abstract I innerProcess(final I input);

    @Required
    public void setProcessingEnabled(Boolean processingEnabled) {
        this.processingEnabled = processingEnabled!=null && processingEnabled;
    }

}
