package pl.edu.icm.synat.process.common.node.processor;

import java.util.Map;

import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.StepExecution;
import org.springframework.batch.core.annotation.BeforeStep;
import org.springframework.batch.item.ItemProcessor;
import org.springframework.beans.factory.annotation.Required;

import pl.edu.icm.synat.process.common.node.scope.JobScopeContext;

public class ItemJobScopeSetterNode<I> implements ItemProcessor<I, I> {

	public static final String ITEM_JOB_SCOPE_KEY = "item";
	
	private JobScopeContext context;
	
	private JobExecution jobExecution;
	
	@BeforeStep
	public void beforeStep(StepExecution stepExecution) {
	    jobExecution = stepExecution.getJobExecution();
	}
	
	public I process(I item) throws Exception {
		Map<String, Object> jobScopeBeans = context.getContext(jobExecution);
		jobScopeBeans.put(ITEM_JOB_SCOPE_KEY, item);
		return item;
	}
	
	@Required
	public void setContext(JobScopeContext context) {
		this.context = context;
	}
	
}
