package pl.edu.icm.synat.process.common.node.processor;

import com.google.common.base.Predicate;

import pl.edu.icm.synat.process.common.node.SkippableNode;

public class PredicateCheckProcessorNode<T> extends SkippableNode<T> {

	private final Predicate<T> predicate;

	public PredicateCheckProcessorNode(Predicate<T> predicate) {
		this.predicate = predicate;
	}

	@Override
	public T innerProcess(T input) {
		return predicate.apply(input) ? input : null;
	}
}
