package pl.edu.icm.synat.process.common.node.processor.predicates;

import org.springframework.beans.factory.annotation.Required;

import com.google.common.base.Predicate;

import pl.edu.icm.synat.api.services.common.Page;
import pl.edu.icm.synat.logic.model.deduplication.Duplicate;
import pl.edu.icm.synat.logic.model.deduplication.DuplicatesQuery;
import pl.edu.icm.synat.logic.services.deduplication.DeduplicationService;

public class DuplicateExistsPredicate implements Predicate<String> {

	private DeduplicationService deduplicationService;

	@Override
	public boolean apply(String input) {
		DuplicatesQuery duplicatesQuery = new DuplicatesQuery();
		duplicatesQuery.setProcessed(true);
		duplicatesQuery.setDuplicateDocumentId(input);
		duplicatesQuery.setPageSize(1);
		Page<Duplicate> duplicatesPage = deduplicationService.fetchPage(duplicatesQuery);
		return duplicatesPage.getTotalSize() > 0l;
	}

	@Required
	public void setDeduplicationService(DeduplicationService deduplicationService) {
		this.deduplicationService = deduplicationService;
	}

}
