package pl.edu.icm.synat.process.common.node.processor.predicates;

import com.google.common.base.Function;
import com.google.common.base.Predicate;

public class FunctionMappingPredicate<T,M> implements Predicate<T>{

	private final Function<T, M> mappingFunction;
	private final Predicate<M> mappedPredicate;
	
	public FunctionMappingPredicate(Function<T, M> mappingFunction, Predicate<M> mappedPredicate) {
		this.mappingFunction = mappingFunction;
		this.mappedPredicate = mappedPredicate;
	}

	@Override
	public boolean apply(T input) {
		return mappedPredicate.apply(mappingFunction.apply(input));
	}

}
