package pl.edu.icm.synat.process.common.node.reader;

import java.util.Map;

import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.StepExecution;
import org.springframework.batch.core.annotation.BeforeStep;
import org.springframework.batch.item.ItemReader;
import org.springframework.batch.item.NonTransientResourceException;
import org.springframework.batch.item.ParseException;
import org.springframework.batch.item.UnexpectedInputException;
import org.springframework.beans.factory.annotation.Required;

import pl.edu.icm.synat.process.common.node.processor.ItemJobScopeSetterNode;
import pl.edu.icm.synat.process.common.node.scope.JobScopeContext;

public class ItemJobScopeReaderNode<T> implements ItemReader<T> {

	private JobScopeContext context;

	private JobExecution jobExecution;

	@BeforeStep
	public void beforeStep(StepExecution stepExecution) {
		jobExecution = stepExecution.getJobExecution();
	}

	@SuppressWarnings("unchecked")
	@Override
	public T read() throws Exception, UnexpectedInputException, ParseException, NonTransientResourceException {
		Map<String, Object> jobScopeBeans = context.getContext(jobExecution);
		return (T) jobScopeBeans.get(ItemJobScopeSetterNode.ITEM_JOB_SCOPE_KEY);
	}
	
	@Required
	public void setContext(JobScopeContext context) {
		this.context = context;
	}

}
