package pl.edu.icm.synat.process.common.node.reader;

import java.io.Serializable;
import java.util.Iterator;

import org.springframework.batch.item.data.AbstractPaginatedDataItemReader;
import org.springframework.beans.factory.annotation.Required;

import pl.edu.icm.synat.api.services.common.Page;
import pl.edu.icm.synat.api.services.common.PageFetchService;
import pl.edu.icm.synat.api.services.common.Query;

public class PageReader<Q extends Query, T extends Serializable> extends AbstractPaginatedDataItemReader<T> {
	
	private PageFetchService<Q, T> service;
	
	private Q query;
	
	@Override
	protected Iterator<T> doPageRead() {
		Page<T> items =  service.fetchPage(query);
		query.setPageNo(query.getPageNo()+1);
		return items.getResult().iterator();
	}

	@Required
	public void setService(PageFetchService<Q, T> service) {
		this.service = service;
	}
	
	@Required
	public void setQuery(Q query) {
		this.query = query;
	}
}
