package pl.edu.icm.synat.process.common.node.scope;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.springframework.batch.core.JobExecution;

public class JobScopeContext {

	private Map<JobExecution, Map<String, Object>> jobExecutionContexts =  new ConcurrentHashMap<JobExecution, Map<String,Object>>();
	
	
	public Map<String, Object> getContext(JobExecution execution){
		 Map<String, Object> ctx = jobExecutionContexts.get(execution);
		 if(ctx == null) {
			 throw new IllegalArgumentException("Execution: "+execution.toString()+" hasn't beent properly initialized");
		 }
		 return ctx;
	}
	
	public void clearContext(JobExecution execution) {
		jobExecutionContexts.remove(execution);
	}
	
	public void buildContext(JobExecution execution) {
		jobExecutionContexts.put(execution, new HashMap<String, Object>());
	}
	
	
}
