package pl.edu.icm.synat.process.common.node.scope;

import javax.annotation.PostConstruct;

import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.listener.JobExecutionListenerSupport;

public class JobScopeListener extends JobExecutionListenerSupport{

	private JobScopeContext context;
	
	@Override
	public void beforeJob(JobExecution jobExecution) {
		context.buildContext(jobExecution);
	}
	
	@Override
	public void afterJob(JobExecution jobExecution) {
		context.clearContext(jobExecution);
	}
	
	public void setContext(JobScopeContext context) {
		this.context = context;
	}
	
	@PostConstruct
	public void initialize() {
		assert(context != null);
	}
	
}
