package pl.edu.icm.synat.process.common.store.impl;

/*
 * #%L
 * Synat: BWMETA indexing process definition and implementation
 * %%
 * Copyright (C) 2010 - 2013 ICM, Warsaw University
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.List;

import org.springframework.batch.item.ItemWriter;

import pl.edu.icm.synat.logic.document.model.api.NativeDocument;

/**
 * 
 * @author Gra <Gołębiewski Radosław A.> google.com/+RadoslawGolebiewski
 */
public class DirectNativeDocumentWriter implements ItemWriter<List<? extends NativeDocument>> {
    private ItemWriter<NativeDocument> writer;

    @Override
    public void write(List<? extends List<? extends NativeDocument>> items) throws Exception {
        for (List<? extends NativeDocument> list : items) {
            writer.write(list);
        }
    }

    public void setWriter(ItemWriter<NativeDocument> writer) {
        this.writer = writer;
    }
}
