package pl.edu.icm.synat.process.common.store.impl;

import com.google.common.base.Function;

import pl.edu.icm.synat.api.services.store.model.Record;
import pl.edu.icm.synat.logic.document.model.api.Document;
import pl.edu.icm.synat.logic.document.model.api.DocumentFactory;
import pl.edu.icm.synat.logic.document.model.api.NativeDocument;

public class DocumentTransformer implements Function<Record, Document>{

	private DocumentFactory documentFactory;

	public void setDocumentFactory(DocumentFactory documentFactory) {
		this.documentFactory = documentFactory;
	}
	
	@Override
	public Document apply(Record input) {
		NativeDocument nativeDocument = documentFactory.getDocument(input);
		if (nativeDocument instanceof Document) {
			return (Document) nativeDocument;
		} else {
			return null;
		}
	}
	
}
