package pl.edu.icm.synat.process.common.store.impl;

import java.util.List;

import com.google.common.base.Function;
import com.google.common.collect.Lists;

import pl.edu.icm.synat.api.services.store.model.Record;
import pl.edu.icm.synat.logic.document.model.api.Document;
import pl.edu.icm.synat.logic.document.model.api.NativeDocument;

public class ListNativeDocumentTransformer implements Function<Record, List<? extends NativeDocument>> {

	private Function<Record, ? extends NativeDocument> singleElementTrasformer;

	public void setSingleElementTrasformer(Function<Record, Document> singleElementTrasformer) {
		this.singleElementTrasformer = singleElementTrasformer;
	}
	
	@Override
	public List<? extends NativeDocument> apply(Record input) {
		NativeDocument document = singleElementTrasformer.apply(input);
		if (document != null) {
			return Lists.newArrayList(document);
		}
		return null;
	}
	
	
}
